package libFLAC;

/** FLAC frame structure.  (c.f. <A HREF="../format.html#frame">format specification</A>)
 */
public final class JFLAC__Frame {
	public final JFLAC__FrameHeader header;
	public final JFLAC__Subframe[] subframes = new JFLAC__Subframe[Jformat.FLAC__MAX_CHANNELS];
	public final JFLAC__FrameFooter footer = new JFLAC__FrameFooter();

	JFLAC__Frame() {
		header = new JFLAC__FrameHeader();
		createSubframeHolders();
	}

	JFLAC__Frame(final JFLAC__FrameHeader frameHeader, final char footerCRC) {
		header = frameHeader;
		footer.crc = footerCRC;
		createSubframeHolders();
	}

	private void createSubframeHolders() {
		for( int i = 0; i < Jformat.FLAC__MAX_CHANNELS; i++ ) {
			subframes[i] = new JFLAC__Subframe();
		}
	}
}
