package test;

import java.lang.reflect.Field;

/**
 * main.c
 *
 * Main class to execute all tests.
 */
public final class Jtests {

	static int getIntegerValue(final Object o, final String valueName) {
		try {
			final Field field = o.getClass().getDeclaredField( valueName );
			field.setAccessible( true );
			return ((Integer)field.get( o )).intValue();
		} catch( final SecurityException e ) {
			e.printStackTrace();
		} catch( final NoSuchFieldException e ) {
			e.printStackTrace();
		} catch( final IllegalArgumentException e ) {
			e.printStackTrace();
		} catch( final IllegalAccessException e ) {
			e.printStackTrace();
		}
		return 0;
	}

	static int[] getIntBuffer(final Object o, final String bufferName) {
		try {
			final Field field = o.getClass().getDeclaredField( bufferName );
			field.setAccessible( true );
			return (int[])field.get( o );
		} catch( final SecurityException e ) {
			e.printStackTrace();
		} catch( final NoSuchFieldException e ) {
			e.printStackTrace();
		} catch( final IllegalArgumentException e ) {
			e.printStackTrace();
		} catch( final IllegalAccessException e ) {
			e.printStackTrace();
		}
		return null;
	}

	static byte[] getByteBuffer(final Object o, final String bufferName) {
		try {
			final Field field = o.getClass().getDeclaredField( bufferName );
			field.setAccessible( true );
			return (byte[])field.get( o );
		} catch( final SecurityException e ) {
			e.printStackTrace();
		} catch( final NoSuchFieldException e ) {
			e.printStackTrace();
		} catch( final IllegalArgumentException e ) {
			e.printStackTrace();
		} catch( final IllegalAccessException e ) {
			e.printStackTrace();
		}
		return null;
	}

	public static int memcmp(final int[] dim1, final int offset1, final int[] dim2, final int offset2, final int count) {
		if( dim1.length - offset1 < count ) {
			return -1;
		}
		if( dim2.length - offset2 < count ) {
			return 1;
		}
		for( int i = 0; i < count; i++ ) {
			final int d1 = dim1[offset1 + i];
			final int d2 = dim2[offset2 + i];
			final int res = d1 - d2;
			if( res != 0 ) {
				return res;
			}
		}
		return 0;
	}

	public static int memcmp(final byte[] dim1, final int offset1, final byte[] dim2, final int offset2, final int count) {
		if( dim1.length - offset1 < count ) {
			return -1;
		}
		if( dim2.length - offset2 < count ) {
			return 1;
		}
		for( int i = 0; i < count; i++ ) {
			final int d1 = dim1[offset1 + i];
			final int d2 = dim2[offset2 + i];
			final int res = d1 - d2;
			if( res != 0 ) {
				return res;
			}
		}
		return 0;
	}

	/**
	 *
	 * @param args is not used
	 */
	public static void main(final String[] args) {
//		if( ! test_endswap() )
//			System.exit( 1 );

//		if( ! test_crc() )
//			System.exit( 1 );

//		if( ! test_md5() )
//			System.exit( 1 );

		if( ! Jbitreader.test_bitreader() ) {
			System.exit( 1 );
		}

		if( ! Jbitwriter.test_bitwriter() ) {
			System.exit( 1 );
		}

//		if( ! test_format() )
//			System.exit( 1 );

//		if( ! test_encoders() )
//			System.exit( 1 );

//		if( ! test_decoders() )
//			System.exit( 1 );

//		if( ! test_metadata() )
//			System.exit( 1 );

		System.exit( 0 );
	}

}
